<template>
  <section
    ref="table_editor"
    table-editor
    data-theme="light"
    @contextmenu="positionContextMenu"
  >
    <div>
      <v-btn
        ref="freezeColBtn"
        width="300px"
        height="30px"
        rounded
        color="secondary"
        :disabled="this.disableCFreeze"
        @click="freezeColumn()"
        >{{ this.freezeColLabel }}</v-btn
      >
      <v-btn
        ref="freezeRowBtn"
        width="300px"
        height="30px"
        rounded
        color="secondary"
        :disabled="this.disableRFreeze"
        @click="freezeRow()"
        >{{ this.freezeRowLabel }}</v-btn
      >
    </div>
    <section context-menu ref="contextmenu">
      <div header-menu :visible="headerContextOpened">
        <ul>
          <li>Freeze column</li>
          <li>header option 2</li>
        </ul>
      </div>
      <div row-menu :visible="rowContextOpened">
        <ul>
          <li @click="freezeRow()">Freeze row</li>
          <li>row option 2</li>
        </ul>
      </div>
    </section>
    <div>
      <div
        ref="sticky_table_div"
        style="width: 800px; height: 400px; float: left; overflow: auto;"
      >
        <table :freezedRowTableStyle="rowsFreezed">
          <thead>
            <tr
              @contextmenu.prevent="headerContextOpened = true"
              class="noselect"
            >
              <!-- headers - style them according to different selectors:
                headerStyle - normal style 
                freezedColStyle - if cells of given column are freezed don't display the header
                headerAlgoStyle - algorithm headers fixed width
                freezedColumnBorder - red border for the column that's freezed
                styles - fixed width for headers when rows are freezed (so the table doesn't shrink)
                       - left and top offsets for the zeroeth and first header in order to make them fully sticky
              -->
              <th
                ref="headers"
                v-for="(c, j) in columnDefs"
                :key="c.headerName"
                @click="selectColumn($event, j - 1, 1)"
                :headerStyle="j > 1"
                :freezedColStyle="
                  (freezedCells.some(obj => obj.col + 1 === j) &&
                    columnsFreezed) ||
                  selectedRowNotVisible
                "
                :headerAlgoStyle="j <= 1"
                :freezedColumnBorder="j == freezedColumn && columnsFreezed"
                :style="[
                  j == 0 && rowsFreezed ? { width: headerZeroWidth } : {},
                  j == 1 && rowsFreezed ? { width: headerOneWidth } : {},
                  j > 1 && rowsFreezed ? { width: headerAboveOneWidth } : {},
                  j == 0 ? { left: 0, top: 0 } : {},
                  j == 1 ? { left: algoHeadLeftOffset, top: 0 } : {},
                ]"
              >
                {{ c.headerName }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="(row, i) in rowData"
              :key="i"
              @contextmenu.prevent="rowContextOpened = true"
            >
              <!-- rows - style them according to different selectors:
                freezedRowStyle - if cells of given row are freezed don't display the row
                rowStickyStyle - row numbers are always sticky
                freezedRowBorder - red border for the row that's freezed
              -->
              <td
                ref="rows"
                @click="selectRow($event, i, 1)"
                class="noselect"
                :freezedRowStyle="
                  (freezedCells.some(obj => obj.row === i) && rowsFreezed) ||
                  selectedColumnNotVisible
                "
                rowStickyStyle
                :freezedRowBorder="i + 1 == freezedRow && rowsFreezed"
              >
                {{ i }}
              </td>
              <!-- table cells - style them according to different selectors:
                selectedColumnStyle - if current column is selected (not algo) colour it blue
                selectedRowStyle - if current row is selected (cannot be selected row and column in the same time) colour it blue
                selectedCellStyle - if current cell is selected colour it blue
                freezedCellStyle - if current cell is freezed hide it
                rowAlgoStyle - if current cell is algorithm cell make it sticky
                freezedRowBorder - red border bottom for the row that's freezed
                freezedColumnBorder - red border right for the column that's freezed 
                styles - left offset for the algorithm sticky cells (computed after mounting)
              -->
              <td
                v-for="(c, j) in columnDefs.slice(1)"
                @click="
                  deselectAll($event, i, j);
                  handleClickOnCell($event, i, j);
                "
                @mousedown="handleMouseDown($event, i, j)"
                @mouseup="handleMouseUp()"
                @mousemove="pickCells($event, i, j)"
                :id="'td_' + i + '_' + j"
                :key="c.headerName"
                :differs="row[c.field] != originalRowData[i][c.field]"
                :selectedColumnStyle="
                  selectedColumns.includes(j) &&
                  j != 0 &&
                  !selectedRows.includes(i)
                "
                :selectedRowStyle="
                  selectedRows.includes(i) && !selectedColumns.includes(j)
                "
                :selectedCellStyle="
                  selectedCells.some(obj => obj.row === i && obj.col === j)
                "
                :freezedCellStyle="
                  freezedCells.some(obj => obj.row === i && obj.col === j)
                "
                :rowAlgoStyle="j == 0"
                :freezedRowBorder="i + 1 == freezedRow && rowsFreezed"
                :freezedColumnBorder="j + 1 == freezedColumn && columnsFreezed"
                :style="[j == 0 ? { left: algoHeadLeftOffset } : {}]"
              >
                <input type="text" v-model="row[c.field]" />
              </td>
            </tr>
          </tbody>
        </table>
      </div>
      <!-- second table div - styling is copy of the first table -->
      <div
        ref="second_table_div"
        style="width: 400px; height: 400px; display: none;"
        @scroll="scrollStickyTableDiv()"
      >
        <table>
          <thead>
            <tr
              @contextmenu.prevent="headerContextOpened = true"
              class="noselect"
            >
              <th
                ref="headers_2"
                v-for="(c, j) in columnDefs"
                :key="c.headerName"
                @click="selectColumn($event, j - 1, 2)"
                :headerStyle="j > 1"
                :freezedColStyle="
                  freezedCells_1.some(obj => obj.col + 1 === j) &&
                  !selectedRowNotVisible
                "
                :style="[
                  j == 0 && rowsFreezed ? { width: headerZeroWidth } : {},
                  j == 1 && rowsFreezed ? { width: headerOneWidth } : {},
                  j > 1 && rowsFreezed ? { width: headerAboveOneWidth } : {},
                  j == 0 ? { left: 0, top: 0 } : {},
                  j == 1 ? { left: algoHeadLeftOffset, top: 0 } : {},
                ]"
                :headerAlgoStyle="j <= 1"
              >
                {{ c.headerName }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="(row, i) in rowData"
              :key="i"
              @contextmenu.prevent="rowContextOpened = true"
            >
              <td
                ref="rows_2"
                @click="selectRow($event, i, 2)"
                class="noselect"
                :freezedRowStyle="
                  freezedCells_1.some(obj => obj.row === i) &&
                  !selectedColumnNotVisible
                "
                rowStickyStyle
              >
                {{ i }}
              </td>
              <td
                v-for="(c, j) in columnDefs.slice(1)"
                @click="
                  deselectAll($event, i, j);
                  handleClickOnCell($event, i, j);
                "
                @mousedown="handleMouseDown($event, i, j)"
                @mouseup="handleMouseUp()"
                @mousemove="pickCells($event, i, j)"
                :id="'td_' + i + '_' + j"
                :key="c.headerName"
                :differs="row[c.field] != originalRowData[i][c.field]"
                :selectedColumnStyle="
                  selectedColumns.includes(j) &&
                  j != 0 &&
                  !selectedRows.includes(i)
                "
                :selectedRowStyle="
                  selectedRows.includes(i) && !selectedColumns.includes(j)
                "
                :selectedCellStyle="
                  selectedCells.some(obj => obj.row === i && obj.col === j)
                "
                :freezedCellStyle="
                  freezedCells_1.some(obj => obj.row === i && obj.col === j)
                "
                :rowAlgoStyle="j === 0"
                :style="[j === 0 ? { left: algoHeadLeftOffset } : {}]"
              >
                <input type="text" v-model="row[c.field]" />
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <!-- Snackbar for the possible future use -->
    <!-- <v-btn dark @click="snackbar = true">Open Snackbar</v-btn> -->
    <v-snackbar v-model="snackbar">
      {{ text }}
      <v-btn color="pink" text @click="snackbar = false">
        Close
      </v-btn>
    </v-snackbar>
  </section>
</template>

<script lang="ts">
/* eslint @typescript-eslint/no-explicit-any: 0 */
import { Component, Vue } from "vue-property-decorator";

@Component({
  components: {},
})
export default class extends Vue {
  //idexes of previous selected row or column
  private previousRow = 0;
  private previousColumn = 0;

  //indexes of freezed row or column
  private freezedRow = 0;
  private freezedColumn = 0;

  //indexes of previously clicked cell row or column
  //used for click + shift selections
  private previousCellRow = 0;
  private previousCellColumn = 0;

  //indexes of previously clicked cell row or column
  //used for mouse selection
  private previousCellRowOnSelect = 0;
  private previousCellColumnOnSelect = 0;

  //arrays of selected columns, rows and cells
  private selectedColumns = [] as any;
  private selectedRows = [] as any;
  private selectedCells = [] as any;

  //flags indicating weather columns and rows are freezed
  private columnsFreezed = false;
  private rowsFreezed = false;

  //arrays holding objects with coordinates of freezed cells for both tables
  private freezedCells = [] as any;
  private freezedCells_1 = [] as any;

  //flag for mousepressed event
  private mousePressed = false;

  //scrollX and scrollY positions for saving scrolls before freezing
  private scrollX = 0;
  private scrollY = 0;

  //scrollX and scrllY of the second table in order to use it on
  //the first table after freezing
  private secondScrollX = 0;
  private secondScrollY = 0;

  //position of the selected column and row in the second table
  private stickyTableSelectedColumnPosition = 0;
  private stickyTableSelectedRowPosition = 0;

  //flags for indicating if selected column or row is outside visible area
  private selectedColumnNotVisible = false;
  private selectedRowNotVisible = false;

  //snackbar variables
  private snackbar = false;
  private text = "";

  //flags for disabling freezing buttons
  private disableCFreeze = true;
  private disableRFreeze = true;

  //text displayed on freezing buttons
  private freezeColLabel = "Freeze columns";
  private freezeRowLabel = "Freeze rows";

  //header width and offset values calculated dynamically
  private headerZeroWidth = "0px";
  private headerOneWidth = "0px";
  private headerAboveOneWidth = "0px";
  private algoHeadLeftOffset = "0px";

  private columnDefs = [
    { headerName: "" },
    { headerName: "Algorithm name", field: "algo" },
    { headerName: "Column 0", field: "col_0" },
    { headerName: "Column 1", field: "col_1" },
    { headerName: "Column 2", field: "col_2" },
    { headerName: "Column 3", field: "col_3" },
    { headerName: "Column 4", field: "col_4" },
    { headerName: "Column 5", field: "col_5" },
    { headerName: "Column 6", field: "col_6" },
    { headerName: "Column 7", field: "col_7" },
  ];

  // prettier-ignore
  private rowData = [
    { algo: "algo A", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A1", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B1", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C1", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D1", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E1", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F1", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G1", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H1", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A2", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B2", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C2", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D2", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E2", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F2", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G2", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H2", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A1", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B1", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C1", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D1", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E1", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F1", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G1", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H1", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A2", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B2", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C2", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D2", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E2", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F2", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G2", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H2", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A1", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B1", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C1", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D1", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E1", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F1", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G1", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H1", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A2", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B2", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C2", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D2", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E2", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F2", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G2", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H2", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
  ];

  // prettier-ignore
  private originalRowData = [
   { algo: "algo A", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A1", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B1", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C1", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D1", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E1", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F1", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G1", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H1", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A2", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B2", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C2", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D2", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E2", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F2", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G2", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H2", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A1", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B1", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C1", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D1", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E1", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F1", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G1", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H1", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A2", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B2", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C2", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D2", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E2", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F2", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G2", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H2", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A1", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B1", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C1", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D1", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E1", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F1", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G1", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H1", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A2", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B2", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C2", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D2", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E2", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F2", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G2", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H2", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
    { algo: "algo A3", col_0: 0, col_1: 1.111, col_2: 1, col_3: 48597, col_4: 0, col_5: 1.111, col_6: 1, col_7: 48597 },
    { algo: "algo B3", col_0: 0, col_1: 2.222, col_2: 2, col_3: 48597, col_4: 0, col_5: 2.222, col_6: 2, col_7: 48597 },
    { algo: "algo C3", col_0: 0, col_1: 3.333, col_2: 3, col_3: 1.487, col_4: 0, col_5: 3.333, col_6: 3, col_7: 1.487 },
    { algo: "algo D3", col_0: 0, col_1: 4.444, col_2: 4, col_3: 100.1, col_4: 0, col_5: 4.444, col_6: 4, col_7: 100.1 },
    { algo: "algo E3", col_0: 0, col_1: 5.555, col_2: 5, col_3: 48597, col_4: 0, col_5: 5.555, col_6: 5, col_7: 48597 },
    { algo: "algo F3", col_0: 0, col_1: 6.666, col_2: 7, col_3: 222.2, col_4: 0, col_5: 6.666, col_6: 7, col_7: 222.2 },
    { algo: "algo G3", col_0: 0, col_1: 7.777, col_2: 7, col_3: 333.3, col_4: 0, col_5: 7.777, col_6: 7, col_7: 333.3 },
    { algo: "algo H3", col_0: 0, col_1: 8.888, col_2: 7, col_3: 444.4, col_4: 0, col_5: 8.888, col_6: 7, col_7: 444.4 },
  ];

  public mounted() {
    const headers = this.$refs.headers as any[];

    document.addEventListener("click", this.closeContextMenu);
    document.addEventListener("keyup", this.handleKeyPress);
    this.restoreTheme();

    //calculate offset of algorithm sticky column dynamically
    this.algoHeadLeftOffset = (headers[0].offsetWidth + 1).toString() + "px";
  }

  public destroyed() {
    document.removeEventListener("click", this.closeContextMenu);
    document.removeEventListener("keyup", this.handleKeyPress);
    // document.removeEventListener('contextmenu', this.openContextMenu)
  }

  private headerContextOpened = false;
  private rowContextOpened = false;
  private closeContextMenu() {
    this.headerContextOpened = false;
    this.rowContextOpened = false;
  }

  private positionContextMenu(event: any) {
    const contextMenu = this.$refs.contextmenu as HTMLElement;
    const rect = this.$root.$el.getBoundingClientRect();

    const x = event.clientX - rect.left;
    const y = event.clientY - rect.top;
    contextMenu.style.left = x + "px";
    contextMenu.style.top = y + "px";
  }
  // private openContextMenu(event: Event) {
  //   // event.stopPropagation();
  //   event.preventDefault()
  //   this.contextOpened = true;
  // }

  private handleKeyPress(event: KeyboardEvent) {
    if (event.keyCode == 27) {
      // esc
      this.closeContextMenu();
    }
  }

  //Column selection function
  private selectColumn(event: MouseEvent, j: any, tableNumber: number) {
    let headers;
    if (tableNumber == 1) headers = this.$refs.headers as any[];
    else headers = this.$refs.headers_2 as any[];

    if (j == 0) return; //zero column cannot be selected (algo names)

    //following only has importance for table 1 (freezing possible on it)
    if (tableNumber == 1 && !this.columnsFreezed && !this.rowsFreezed) {
      //column has to be fully visible to be able to select to avoid positioning problems
      if (!this.isSelectedColumnFullyVisible(headers[j], j)) return;

      //is selected column far enough from the right border so there is enough to scroll
      if (this.isSelectedColumnFreezable()) this.disableCFreeze = false;
      else this.disableCFreeze = true;

      this.disableRFreeze = true;
    }

    //deselect all row selections
    this.deselectRows();
    if (event.ctrlKey) {
      //in case of multiple selection add column if it doesn't exist in selection
      if (!this.selectedColumns.includes(j)) {
        this.selectedColumns.push(j);
      } else {
        const index = this.selectedColumns.indexOf(j);
        if (index !== -1) this.selectedColumns.splice(index, 1);
      }
    } else if (event.shiftKey) {
      //if shift is pressed add multiple columns
      if (!this.selectedColumns.includes(j)) {
        if (this.previousColumn < j) {
          for (let iter = this.previousColumn; iter <= j; iter++) {
            this.selectedColumns.push(iter);
          }
        } else {
          for (let iter = j; iter <= this.previousColumn; iter++) {
            this.selectedColumns.push(iter);
          }
        }
      }
    } else {
      //in case it's not ctrl and not shift, just add this one column
      this.selectedColumns = [];
      this.selectedColumns.push(j);
    }
    this.previousColumn = j;
    this.previousCellColumn = j;
  }

  private selectRow(event: MouseEvent, i: any, tableNumber: number) {
    const rows = this.$refs.rows as any[];

    if (tableNumber == 1 && !this.rowsFreezed && !this.columnsFreezed) {
      //row has te be fully visible to be able to select
      if (!this.isSelectedRowFullyVisible(rows[i], i)) return;

      //is selected row far enough from the bottom border so there is enough to scroll
      if (this.isSelectedRowFreezable() && i != 0) this.disableRFreeze = false;
      else this.disableRFreeze = true;

      this.disableCFreeze = true;
    }

    //deselect all column selections
    this.deselectColumns();
    if (event.ctrlKey) {
      //in case of multiple selection add row if it doesn't exist in selection
      if (!this.selectedRows.includes(i)) {
        this.selectedRows.push(i);
      } else {
        const index = this.selectedRows.indexOf(i);
        if (index !== -1) this.selectedRows.splice(index, 1);
      }
    } else if (event.shiftKey) {
      //if shift is pressed add multiple rows
      if (!this.selectedRows.includes(i)) {
        if (this.previousRow < i) {
          for (let iter = this.previousRow; iter <= i; iter++) {
            this.selectedRows.push(iter);
          }
        } else {
          for (let iter = i; iter <= this.previousRow; iter++) {
            this.selectedRows.push(iter);
          }
        }
      }
    } else {
      //in case it's not ctrl and not shift, just add this one row
      this.selectedRows = [];
      this.selectedRows.push(i);
    }
    this.previousRow = i;
    this.previousCellRow = i;
  }

  //if mouse is not pressed with shift or ctrl deselect all cells,
  //in any case deselect rows and columns
  private deselectAll(event: MouseEvent, i: any, j: any) {
    if (!event.shiftKey && !event.ctrlKey) {
      this.previousCellRow = i;
      this.previousCellColumn = j;
      this.selectedCells = [];
    }
    this.selectedRows = [];
    this.selectedColumns = [];
  }

  //deselect all rows
  private deselectRows() {
    this.previousRow = 0;
    this.previousCellRow = 0;
    this.previousCellColumn = 0;
    this.selectedRows = [];
    this.selectedCells = [];
  }

  //deselect all columns
  private deselectColumns() {
    this.previousColumn = 0;
    this.previousCellRow = 0;
    this.previousCellColumn = 0;
    this.selectedColumns = [];
    this.selectedCells = [];
  }

  //cell click handler function
  private handleClickOnCell(event: MouseEvent, i: any, j: any) {
    //draw rectangle if shift is pressed
    if (event.shiftKey && j != 0 && this.previousCellColumn != 0) {
      if (i == this.previousCellRow && j == this.previousCellColumn) {
        //one cell selected
        this.selectedCells.push({ row: i, col: j });
      } else {
        this.selectedCells = [];
        if (i > this.previousCellRow) {
          //multiple cells selected to DOWN of the first selected row
          if (j == this.previousCellColumn) {
            //just down the same column
            for (let iter = this.previousCellRow; iter <= i; iter++) {
              this.selectedCells.push({ row: iter, col: j });
            }
          } else {
            //DOWN and RIGHT of the current row
            if (j > this.previousCellColumn) {
              for (let iter1 = this.previousCellRow; iter1 <= i; iter1++) {
                for (let iter2 = this.previousCellColumn; iter2 <= j; iter2++) {
                  this.selectedCells.push({ row: iter1, col: iter2 });
                }
              }
            } else {
              //DOWN and LEFT of the current row
              for (let iter1 = this.previousCellRow; iter1 <= i; iter1++) {
                for (let iter2 = j; iter2 <= this.previousCellColumn; iter2++) {
                  this.selectedCells.push({ row: iter1, col: iter2 });
                }
              }
            }
          }
        } else {
          //multiple cells selected to UP of the first selected row
          if (j == this.previousCellColumn) {
            for (let iter = i; iter <= this.previousCellRow; iter++) {
              this.selectedCells.push({ row: iter, col: j });
            }
          } else {
            //UP and RIGHT of the current row
            if (j > this.previousCellColumn) {
              for (let iter1 = i; iter1 <= this.previousCellRow; iter1++) {
                for (let iter2 = this.previousCellColumn; iter2 <= j; iter2++) {
                  this.selectedCells.push({ row: iter1, col: iter2 });
                }
              }
            } else {
              //UP and LEFT of the current row
              for (let iter1 = i; iter1 <= this.previousCellRow; iter1++) {
                for (let iter2 = j; iter2 <= this.previousCellColumn; iter2++) {
                  this.selectedCells.push({ row: iter1, col: iter2 });
                }
              }
            }
          }
        }
      }
    } else if (event.ctrlKey && j != 0 && this.previousCellColumn != 0) {
      //Ctrl click
      this.selectedCells.push({ row: i, col: j });
    }
  }

  //mouse down cell handler function used for mouse selections
  private handleMouseDown(event: MouseEvent, i: any, j: any) {
    if (j != 0) {
      this.mousePressed = true;
      this.previousCellRowOnSelect = i;
      this.previousCellColumnOnSelect = j;
    }
  }

  //mouse up cell handler function used for mouse selections
  private handleMouseUp() {
    this.mousePressed = false;
  }

  //function used to pick cells on mouse move (mouse selection)
  private pickCells(event: MouseEvent, i: any, j: any) {
    if (this.mousePressed) {
      if (i > this.previousCellRowOnSelect) {
        //multiple cells selected to DOWN of the first selected row
        if (j == this.previousCellColumnOnSelect) {
          //just down the same column
          for (let iter = this.previousCellRowOnSelect; iter <= i; iter++) {
            if (
              !this.selectedCells.some(
                (obj: any) => obj.row === iter && obj.col === j //if not already in the array
              )
            )
              this.selectedCells.push({ row: iter, col: j });
          }
        } else {
          //DOWN and RIGHT of the current row
          if (j > this.previousCellColumnOnSelect) {
            for (
              let iter1 = this.previousCellRowOnSelect;
              iter1 <= i;
              iter1++
            ) {
              for (
                let iter2 = this.previousCellColumnOnSelect;
                iter2 <= j;
                iter2++
              ) {
                if (
                  !this.selectedCells.some(
                    (obj: any) => obj.row === iter1 && obj.col === iter2 //if not already in the array
                  )
                )
                  this.selectedCells.push({ row: iter1, col: iter2 });
              }
            }
          } else {
            //DOWN and LEFT of the current row
            for (
              let iter1 = this.previousCellRowOnSelect;
              iter1 <= i;
              iter1++
            ) {
              for (
                let iter2 = j;
                iter2 <= this.previousCellColumnOnSelect;
                iter2++
              ) {
                if (
                  !this.selectedCells.some(
                    (obj: any) => obj.row === iter1 && obj.col === iter2 //if not already in the array
                  )
                )
                  this.selectedCells.push({ row: iter1, col: iter2 });
              }
            }
          }
        }
      } else {
        //multiple cells selected to UP of the first selected row
        if (j == this.previousCellColumnOnSelect) {
          for (let iter = i; iter <= this.previousCellRowOnSelect; iter++) {
            if (
              !this.selectedCells.some(
                (obj: any) => obj.row === iter && obj.col === j //if not already in the array
              )
            )
              this.selectedCells.push({ row: iter, col: j });
          }
        } else {
          //UP and RIGHT of the current row
          if (j > this.previousCellColumnOnSelect) {
            for (
              let iter1 = i;
              iter1 <= this.previousCellRowOnSelect;
              iter1++
            ) {
              for (
                let iter2 = this.previousCellColumnOnSelect;
                iter2 <= j;
                iter2++
              ) {
                if (
                  !this.selectedCells.some(
                    (obj: any) => obj.row === iter1 && obj.col === iter2 //if not already in the array
                  )
                )
                  this.selectedCells.push({ row: iter1, col: iter2 });
              }
            }
          } else {
            //UP and LEFT of the current row
            for (
              let iter1 = i;
              iter1 <= this.previousCellRowOnSelect;
              iter1++
            ) {
              for (
                let iter2 = j;
                iter2 <= this.previousCellColumnOnSelect;
                iter2++
              ) {
                if (
                  !this.selectedCells.some(
                    (obj: any) => obj.row === iter1 && obj.col === iter2 //if not already in the array
                  )
                )
                  this.selectedCells.push({ row: iter1, col: iter2 });
              }
            }
          }
        }
      }
    }
  }

  //function for column freezing
  private freezeColumn() {
    const headers = this.$refs.headers as any[];
    const headers_2 = this.$refs.headers_2 as any[];
    const rows = this.$refs.rows as any[];
    const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;
    const secondTableDiv = this.$refs.second_table_div as HTMLElement;
    const freezeColBtn = this.$refs.freezeColBtn as any;

    //check weather selected column is fully visible (if not first table won't be shown at all)
    if (!this.isSelectedColumnFullyVisible(headers[1], this.previousColumn)) {
      this.selectedColumnNotVisible = true;
    }

    //switch freezed flag
    this.columnsFreezed = !this.columnsFreezed;

    if (this.columnsFreezed) {
      /*if selected column is visible don't display first header of second table
        otherwise display it this will in turn produce other table to show row numbers 
        instead the first one
      */
      if (!this.selectedColumnNotVisible) headers_2[0].style.display = "none";
      else headers_2[0].style.display = "";

      //clear all selector arrays
      this.selectedColumns = [];
      this.selectedRows = [];
      this.selectedCells = [];

      //remember scroll posotion prior to freezing
      this.scrollX = stickyTableDiv.scrollLeft;
      this.scrollY = stickyTableDiv.scrollTop;
      this.freezeColLabel = "Unfreeze columns";

      if (this.previousColumn != -1) {
        //first hide the columns of the first table (freeze them)
        for (let iter1 = 0; iter1 < this.rowData.length; iter1++) {
          for (
            let iter2 = this.previousCellColumn;
            iter2 <= this.columnDefs.length;
            iter2++
          ) {
            this.freezedCells.push({ row: iter1, col: iter2 });
          }
        }
        //second table has to be position absolutely to 0,0
        secondTableDiv.style.position = "absolute";
        secondTableDiv.style.display = ""; //show it

        //if selected column is visible calculate second table
        //left position as width of header * previousColumn + rows width -
        //scrollLeft
        if (!this.selectedColumnNotVisible)
          secondTableDiv.style.left =
            (
              headers[1].offsetWidth * this.previousColumn +
              rows[1].offsetWidth -
              stickyTableDiv.scrollLeft
            ).toString() + "px";
        else secondTableDiv.style.left = "0px"; //otherwise show only second table

        //second table div has to be under freeze buttons
        secondTableDiv.style.top = freezeColBtn.height;
        const stickyOldWidth = parseInt(stickyTableDiv.style.width); //remember sticky table width

        //if selected column is visible shrink
        //sticky table width to the freezed column - basically same calculation
        //as left of the second table
        if (!this.selectedColumnNotVisible)
          stickyTableDiv.style.width =
            (
              headers[1].offsetWidth * this.previousColumn +
              rows[1].offsetWidth -
              stickyTableDiv.scrollLeft
            ).toString() + "px";
        else stickyTableDiv.style.width = "0px"; //otherwise show only second table

        //if selected column is visible shrink
        //height of the table to the a bit so it doesn't fall out of second table scroller
        if (!this.selectedColumnNotVisible)
          stickyTableDiv.style.height =
            (
              parseInt(stickyTableDiv.style.height) - headers[1].offsetHeight
            ).toString() + "px";
        else stickyTableDiv.style.height = "0px"; //otherwise show only second table

        //if selected column is visible shrink
        //second table width is old sticky table width - new sticky table width
        if (!this.selectedColumnNotVisible)
          secondTableDiv.style.width =
            stickyOldWidth - parseInt(stickyTableDiv.style.width) + "px";
        //otherwise second table width is full old sticky table width
        else secondTableDiv.style.width = stickyOldWidth.toString() + "px";

        //enable both scrollers on the second table
        secondTableDiv.style.overflowX = "auto";
        secondTableDiv.style.overflowY = "auto";

        //fix the top scroll of the second table
        //if first table is not scrolled - 0, otherwise scroll plus header
        if (this.scrollY == 0) secondTableDiv.scrollTop = 0;
        else secondTableDiv.scrollTop = this.scrollY + headers[0].offsetHeight;
        secondTableDiv.scrollLeft = 0;

        //disable scrolling option on first table
        stickyTableDiv.style.overflow = "hidden";

        //save selected column position
        this.stickyTableSelectedColumnPosition =
          headers[this.previousCellColumn].offsetWidth *
          (this.previousColumn - 1);

        //first column to hide in second table -
        //in case selected column is not visible
        //hide only columns starting from one (algorithm column)
        let firstColumnToHide = 0;

        if (this.selectedColumnNotVisible) {
          firstColumnToHide = 1;
        }

        //hide the columns of the second table
        for (let iter1 = 0; iter1 < this.rowData.length; iter1++) {
          for (
            let iter2 = firstColumnToHide;
            iter2 < this.previousCellColumn;
            iter2++
          ) {
            this.freezedCells_1.push({ row: iter1, col: iter2 });
          }
        }
      }
      this.freezedColumn = this.previousColumn; //sasve freezed column
    } else {
      //reset original styling of the sticky table div
      stickyTableDiv.style.width = "800px";
      stickyTableDiv.style.height = "400px";
      stickyTableDiv.style.overflow = "auto";

      //reset original styling of the secont table div
      secondTableDiv.style.height = "400px";
      secondTableDiv.style.width = "400px";
      secondTableDiv.style.display = "none";
      //headers_2[0].style.display = "none";
      //reset flags
      this.selectedColumnNotVisible = false;
      this.disableCFreeze = true;
      this.freezeColLabel = "Freeze columns";

      //unfreeze all cells
      this.freezedCells = [];
      this.freezedCells_1 = [];
      this.deselectColumns();

      //return scrollers to the state before freezing (has to be done after DOM refresh)
      this.$nextTick(() => {
        const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;
        stickyTableDiv.scrollLeft =
          this.secondScrollX + this.stickyTableSelectedColumnPosition;
        stickyTableDiv.scrollTop = this.secondScrollY;
      });
      this.freezedColumn = 0;
    }
  }

  private freezeRow() {
    const headers = this.$refs.headers as any[];
    const headers_2 = this.$refs.headers_2 as any[];
    const rows = this.$refs.rows as any[];
    const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;
    const secondTableDiv = this.$refs.second_table_div as HTMLElement;
    const freezeColBtn = this.$refs.freezeColBtn as any;
    const row_padding = 1; //small padding in order to show freezing border better

    //fix width of first table headers to the widest possible so the first table headers
    //don't shrink when last rows are freezed (hidden)
    this.headerZeroWidth =
      rows[this.rowData.length - 1].offsetWidth.toString() + "px";
    this.headerOneWidth = headers[1].offsetWidth.toString() + "px";
    this.headerAboveOneWidth = headers[2].offsetWidth.toString() + "px";

    //switch freezed flag
    this.rowsFreezed = !this.rowsFreezed;

    if (this.rowsFreezed) {
      if (this.previousRow == 0) return; //zeroth row cannot be freezed

      //check weather selected row is fully visible (if not first table won't be shown at all)
      if (
        !this.isSelectedRowFullyVisible(
          rows[this.previousRow],
          this.previousRow
        )
      ) {
        this.selectedRowNotVisible = true;
      }

      //clear all selector arrays
      this.selectedColumns = [];
      this.selectedRows = [];
      this.selectedCells = [];

      //remember scroll posotion prior to freezing
      this.scrollX = stickyTableDiv.scrollLeft;
      this.scrollY = stickyTableDiv.scrollTop;

      this.freezeRowLabel = "Unfreeze rows";

      //get row info before style change
      const freezedRowCell = rows[0];
      const freezedRowCellRect = freezedRowCell.getBoundingClientRect();

      if (this.previousRow != -1) {
        //first hide the columns of the first table
        for (
          let iter1 = this.previousRow;
          iter1 < this.rowData.length;
          iter1++
        ) {
          for (let iter2 = 0; iter2 <= this.columnDefs.length; iter2++) {
            this.freezedCells.push({ row: iter1, col: iter2 });
          }
        }
        //second table has to be position absolutely to 0,0
        secondTableDiv.style.position = "absolute";
        secondTableDiv.style.display = ""; //show it

        //if selected row is visible calculate second table
        //top position as height of header * (previousRow + 1) -
        //scrollTop + small padding to show border better
        if (!this.selectedRowNotVisible) {
          headers_2[0].style.display = "none";
          secondTableDiv.style.top =
            (
              parseInt(freezeColBtn.height) +
              headers[0].offsetHeight * (this.previousRow + 1) -
              stickyTableDiv.scrollTop +
              row_padding
            ).toString() + "px";
          secondTableDiv.style.left = "0px"; //always on left
        } else {
          //otherwise show heaer_2 zero (small rectangle)
          //top is just below freeze buttons, left still zero
          headers_2[0].style.display = "";
          secondTableDiv.style.top = freezeColBtn.height;
          secondTableDiv.style.left = "0px";
        }
        //remember sticky table width
        const stickyOldHeight = parseInt(stickyTableDiv.style.height);

        //if selected row is visible shrink
        //sticky table height to the freezed column - basically same calculation
        //as top of the second table
        if (!this.selectedRowNotVisible) {
          stickyTableDiv.style.height =
            (
              headers[0].offsetHeight * (this.previousRow + 1) -
              stickyTableDiv.scrollTop +
              row_padding
            ).toString() + "px";
        } else {
          stickyTableDiv.style.height = "0px"; //otherwise show only second table
        }

        //make sticky table a bit less wide (so columns don't drop out of second table scroll)
        stickyTableDiv.style.width =
          (parseInt(stickyTableDiv.style.width) - 20).toString() + "px";

        //if selected row is visible shrink
        //second table height is old sticky table height - new sticky table height
        if (!this.selectedRowNotVisible) {
          secondTableDiv.style.height =
            stickyOldHeight - parseInt(stickyTableDiv.style.height) + "px";
        } else {
          //otherwise second table height is full old sticky table height
          secondTableDiv.style.height = stickyOldHeight + "px";
        }
        //second table is maximal width
        secondTableDiv.style.width = "800px";
        //enable both scrollers on the second table
        secondTableDiv.style.overflowX = "auto";
        secondTableDiv.style.overflowY = "auto";

        //fix the left scroll of the second table
        //if first table is not scrolled -0 , scrollX if it is scrolled
        if (this.scrollX == 0) secondTableDiv.scrollLeft = 0;
        else secondTableDiv.scrollLeft = this.scrollX;
        secondTableDiv.scrollTop = 0;

        //disable scrolling option on first table
        stickyTableDiv.style.overflow = "hidden";

        //offset scroll of unfreezed table to the selected row (plus other scroll later)
        this.stickyTableSelectedRowPosition =
          freezedRowCellRect.height * (this.previousRow - 1);

        //hide the rows of the second table
        for (let iter1 = 0; iter1 < this.previousCellRow; iter1++) {
          for (let iter2 = 0; iter2 < this.columnDefs.length; iter2++) {
            this.freezedCells_1.push({ row: iter1, col: iter2 });
          }
        }
        this.freezedRow = this.previousRow;
      }
    } else {
      //reset original styling of the sticky table div
      stickyTableDiv.style.width = "800px";
      stickyTableDiv.style.height = "400px";
      stickyTableDiv.style.overflow = "auto";

      //reset original styling of the secont table div
      secondTableDiv.style.height = "400px";
      secondTableDiv.style.width = "400px";
      secondTableDiv.style.display = "none";
      //reset flags
      this.selectedRowNotVisible = false;
      this.disableRFreeze = true;
      this.freezeRowLabel = "Freeze rows";

      //unfreeze all cells
      this.freezedCells = [];
      this.freezedCells_1 = [];
      this.deselectRows();

      //return scrollers to the state before freezing (has to be done after DOM refresh)
      this.$nextTick(() => {
        const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;
        stickyTableDiv.scrollLeft = this.secondScrollX;
        stickyTableDiv.scrollTop =
          this.secondScrollY + this.stickyTableSelectedRowPosition;
      });

      this.freezedRow = 0;
    }
  }

  // Only completely visible columns return true
  private isSelectedColumnFullyVisible(el: HTMLElement, j: any) {
    const headers = this.$refs.headers as any[];
    const tableDiv = this.$refs.sticky_table_div as HTMLElement;

    const isVisible =
      el.offsetWidth * j + 1 - (tableDiv.scrollLeft + headers[1].offsetWidth) >
      0;

    return isVisible;
  }

  // Only completely visible columns return true
  private isSelectedRowFullyVisible(el: HTMLElement, i: any) {
    const tableDiv = this.$refs.sticky_table_div as HTMLElement;

    const isVisible = el.offsetHeight * i - tableDiv.scrollTop > 0;

    return isVisible;
  }

  // Only columns far enough from right border return true
  private isSelectedColumnFreezable() {
    const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;

    const isFreezable =
      stickyTableDiv.scrollWidth - stickyTableDiv.scrollLeft >
      parseInt(stickyTableDiv.style.width);

    return isFreezable;
  }

  // Only rows far enough from bottom border return true
  private isSelectedRowFreezable() {
    const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;

    const isFreezable =
      stickyTableDiv.scrollHeight - stickyTableDiv.scrollTop >
      parseInt(stickyTableDiv.style.height);

    return isFreezable;
  }

  //function used to scroll sticky table scroll along with second table scroll
  private scrollStickyTableDiv() {
    const stickyTableDiv = this.$refs.sticky_table_div as HTMLElement;
    const secondTableDiv = this.$refs.second_table_div as HTMLElement;
    if (this.rowsFreezed) stickyTableDiv.scrollLeft = secondTableDiv.scrollLeft;
    if (this.columnsFreezed)
      stickyTableDiv.scrollTop = secondTableDiv.scrollTop;

    this.secondScrollX = secondTableDiv.scrollLeft;
    this.secondScrollY = secondTableDiv.scrollTop;
  }

  //TODO: fix theming
  private restoreTheme() {
    const currentTheme = localStorage.getItem("theme")
      ? localStorage.getItem("theme")
      : null;

    if (currentTheme) {
      const mainEditorFrame = this.$refs.table_editor as HTMLElement;

      if (currentTheme === "dark") {
        mainEditorFrame.setAttribute("data-theme", "dark");
        //localStorage.setItem("theme", "dark");
      } else {
        mainEditorFrame.setAttribute("data-theme", "light");
        //localStorage.setItem("theme", "light");
      }
    }
  }
}
</script>

<style scoped lang="scss">
[data-theme="light"] {
  --primary-color: #302ae6;
  --secondary-color: #536390;
  --font-color: #424242;
  --bg-color: white;
  --heading-color: #292922;
}

[data-theme="dark"] {
  --primary-color: #9a97f3;
  --secondary-color: #818cab;
  --font-color: #e1e1ff;
  --bg-color: #161625;
  --heading-color: white;
}

$context-background: var(--bg-color);
$context-font: var(--font-color);
$context-boder: var(--heading-color);

[table-editor] {
  overflow: auto;
  width: 1400px;
  [context-menu] {
    position: absolute;
    & > div {
      display: none;
      &[visible] {
        display: block;
      }
    }
  }
}
[header-menu] {
  background: $context-background;
  color: $context-font;
  & > ul {
    border: 1px solid black;
  }
  & > ul > li {
    border: 1px solid black;
    padding: 5px;
  }
}

table {
  border-collapse: separate;
  &[freezedRowTableStyle] {
    table-layout: fixed;
    width: 200%;
  }
  thead {
    tr {
      th {
        padding: 1px;
        border: 1px solid $context-boder;
        &[headerStyle] {
          background-color: rgb(177, 177, 177);
          font-weight: bold;
          //border: 2px solid $context-boder;
          position: -webkit-sticky; /* Safari */
          position: sticky;
          top: 0;
          opacity: 1;
          z-index: 5;
          box-shadow: 0 0 2px 1px;
        }
        &[headerAlgoStyle] {
          background-color: rgb(177, 177, 177);
          font-weight: bold;
          //border: 2px solid $context-boder;
          position: -webkit-sticky; /* Safari */
          position: sticky;
          opacity: 1;
          z-index: 6;
          box-shadow: 0 0 2px 1px;
        }
        &[freezedColumnBorder] {
          border-right: 2px solid red;
        }
        &[freezedColStyle] {
          display: none;
        }
      }
    }
  }
  tbody {
    tr {
      td {
        padding: 1px;
        border: 1px solid $context-boder;
        &[rowStickyStyle] {
          background-color: rgb(177, 177, 177);
          font-weight: bold;
          position: -webkit-sticky; /* Safari */
          position: sticky;
          left: 0;
          opacity: 1;
          box-shadow: 0 0 2px 1px;
        }
        &[rowAlgoStyle] {
          background-color: rgb(177, 177, 177);
          font-weight: bold;
          position: -webkit-sticky; /* Safari */
          position: sticky;
          opacity: 1;
          box-shadow: 0 0 2px 1px;
          //pointer-events: none;
        }
        &[freezedColumnBorder] {
          border-right: 2px solid red;
        }
        &[freezedRowBorder] {
          border-bottom: 2px solid red;
        }
        &[differs] {
          input {
            background: yellow;
          }
        }
        &[selectedRowStyle] {
          input {
            background: lightblue;
          }
        }
        &[selectedColumnStyle] {
          input {
            background: lightblue;
          }
        }
        &[selectedCellStyle] {
          input {
            background: lightblue;
          }
        }
        &[freezedCellStyle] {
          display: none;
        }
        &[freezedRowStyle] {
          display: none;
        }
      }
    }
  }
}

.noselect {
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -khtml-user-select: none; /* Konqueror HTML */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently supported by Chrome, Opera and Firefox */
}
</style>
